Module basCommandExamples

    Sub UseAStoredProcedureWithAParameter(ByVal txtResults As TextBox)

        Dim cnn As New ADODB.Connection()
        Dim rstCurr As New ADODB.Recordset()
        Dim cmd As New ADODB.Command()
        Dim prm As ADODB.Parameter

        Try
            cmd.CommandText = "CustOrderHist"
            cmd.CommandType = ADODB.CommandTypeEnum.adCmdStoredProc
            prm = cmd.CreateParameter("CustomerID", ADODB.DataTypeEnum.adChar, _
                                            ADODB.ParameterDirectionEnum.adParamInput, 5)

            cmd.Parameters.Append(prm)
            prm.Value = "CHOPS"

            OpenNorthwindADOConnection(cnn)

            cmd.ActiveConnection = cnn

            rstCurr.Open(cmd)

            txtResults.Text = rstCurr.GetString

        Catch excp As Exception
            MessageBox.Show(excp.Message)
        End Try

    End Sub

    Sub ExecuteABatchCommand(ByVal txtResults As TextBox)

        Dim cnn As New ADODB.Connection()
        Dim cmd As New ADODB.Command()
        Dim prm As ADODB.Parameter
        Dim rstOld As New ADODB.Recordset()
        Dim rstNew As New ADODB.Recordset()

        '-- In .NET we can assign values as we declare variables
        Dim strSQL As String = "Update Orders Set ShippedDate = ShippedDate+1"
        Dim strDispSQL As String = _
                "Select OrderID, ShippedDate From Orders Where OrderID < 10251"

        '-- Open the connection
        OpenNorthwindADOConnection(cnn)

        '-- Open the Orders table and display the ShippedDate as they were.
        rstOld.Open(strDispSQL, cnn)
        txtResults.Text = "Old Values: " & vbCrLf & vbCrLf & rstOld.GetString

        '-- Set up the Command object to use the SQL string.
        cmd.ActiveConnection = cnn
        cmd.CommandText = strSQL
        cmd.CommandType = ADODB.CommandTypeEnum.adCmdText

        '-- Execute the command    
        cmd.Execute()

        '-- Reopen the Orders table and redisplay the ShippedDate Field    
        rstNew.Open(strDispSQL, cnn)
        txtResults.Text = txtResults.Text & vbCrLf & vbCrLf & "New Values: " & _
                                        vbCrLf & vbCrLf & rstNew.GetString

    End Sub

    Sub CreatingASQLServerObjectFromADO(ByVal txtResults As TextBox)

        Dim cnn As New ADODB.Connection()
        Dim cmd As New ADODB.Command()
        Dim rstOld As New ADODB.Recordset()
        Dim rstNew As New ADODB.Recordset()

        '-- In .NET we can assign values as we declare variables, this is where the hard work is.
        Dim strSQL As String = "CREATE TABLE Test (PrimaryIntFld Integer IDENTITY(1,1) PRIMARY KEY, Field2 Text)"

        '-- Open the connection
        OpenNorthwindADOConnection(cnn)

        '-- Set up the Command object to use the SQL string.
        cmd.ActiveConnection = cnn
        cmd.CommandText = strSQL
        cmd.CommandType = ADODB.CommandTypeEnum.adCmdText

        '-- Execute the command    
        cmd.Execute()

    End Sub

End Module
