Module basRecordsetExamples

    Sub OpenRecordsetWithGetStringDisplayExample(ByVal txtResults As TextBox)

        Dim cnn As New ADODB.Connection()
        Dim rstCurr As New ADODB.Recordset()

        OpenNorthwindADOConnection(cnn)

        rstCurr.Open("Select * from Orders where OrderDate = '06/12/97'", cnn, _
                                ADODB.CursorTypeEnum.adOpenForwardOnly)

        txtResults.Text = rstCurr.GetString

        rstCurr.Close()

    End Sub

    Sub OpenRecordsetWithEditingExample(ByVal txtResults As TextBox)

        Dim cnn As New ADODB.Connection()
        Dim rstCurr As New ADODB.Recordset()
        Dim fldCurr As ADODB.Field
        Dim strTemp As String

        OpenNorthwindADOConnection(cnn)


        rstCurr.Open("Select * from Orders where OrderDate = '06/12/97'", cnn, _
                                ADODB.CursorTypeEnum.adOpenDynamic, _
                                ADODB.LockTypeEnum.adLockOptimistic)

        With rstCurr

            Do Until .EOF

                strTemp = strTemp & " Old Field Value: " & .Fields("ShippedDate").Value

                '-- Updating the release date
                .Fields("ShippedDate").Value = DateAdd(DateInterval.Day, 5, .Fields("ShippedDate").Value)

                .Update()

                strTemp = strTemp & " New Field Value: " & .Fields("ShippedDate").Value & vbCrLf

                .MoveNext()

            Loop

        End With

        txtResults.Text = strTemp

        rstCurr.Close()

    End Sub


    Sub PersistingARecordset(ByVal txtResults As TextBox)

        Dim cnn As New ADODB.Connection()
        Dim rstOrig As New ADODB.Recordset()
        Dim rstPersist As New ADODB.Recordset()
        Const adCmdFile As Long = 256

        OpenNorthwindADOConnection(cnn)

        '--  Open forward only and readonly since we are just saving it to disk.
        rstOrig.Open("Select * from Orders where OrderDate = '06/12/97'", cnn, _
                                ADODB.CursorTypeEnum.adOpenStatic)

        txtResults.Text = "Orginal Records : " & vbCrLf & rstOrig.GetString

        '-- Delete the old copy, if there is one, if you don't you will get an error.
        On Error Resume Next
        Kill("OrdersForDate.rst")

        '-- Creating the persistent recordset in the applications directory
        On Error GoTo 0
        rstOrig.Save("OrdersForDate.rst", ADODB.PersistFormatEnum.adPersistADTG)

        cnn = Nothing
        rstOrig = Nothing

        ' Open the persisted recordset
        rstPersist.Open("OrdersForDate.rst", Options:=adCmdFile)

        txtResults.Text = txtResults.Text & vbCrLf & vbCrLf & "Persisted File : " & vbCrLf & rstPersist.GetString

        rstPersist.Close()

    End Sub

End Module
