Option Explicit On 
Option Strict On

Public Class frmHowTo9_4
    Inherits CustomerClasses.frmHowTo9xBase

    Private mCustomer As CCustomer9_4

    Private Sub btnRetrieve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRetrieve.Click

        Try
            mCustomer = New CCustomer9_4(Me.txtCustomerID.Text)
            GetProperties()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


    Private Sub GetProperties()

        Me.txtAddress.Text = mCustomer.Address
        Me.txtCity.Text = mCustomer.City
        Me.txtCompanyName.Text = mCustomer.CompanyName
        Me.txtContactName.Text = mCustomer.ContactName
        Me.txtContactTitle.Text = mCustomer.ContactTitle
        Me.txtCountry.Text = mCustomer.Country
        Me.txtCustomerID.Text = mCustomer.CustomerID
        Me.txtFax.Text = mCustomer.Fax
        Me.txtPhone.Text = mCustomer.Phone
        Me.txtRegion.Text = mCustomer.Region
        Me.txtPostalCode.Text = mCustomer.PostalCode

    End Sub

    Protected Overrides Sub TextBoxChange(ByVal pstrProperty As String, ByVal pstrValue As String)

        Try

            Select Case pstrProperty

                Case "Address"
                    mCustomer.Address = pstrValue

                Case "CompanyName"
                    mCustomer.CompanyName = pstrValue

                Case "ContactTitle"
                    mCustomer.ContactTitle = pstrValue

                Case "ContactName"
                    mCustomer.ContactName = pstrValue

                Case "City"
                    mCustomer.City = pstrValue

                Case "Zip"
                    mCustomer.PostalCode = pstrValue

                Case "Country"
                    mCustomer.Country = pstrValue

                Case "Region"
                    mCustomer.Region = pstrValue

                Case "Phone"
                    mCustomer.Phone = pstrValue

                Case "Fax"
                    mCustomer.Fax = pstrValue

            End Select


            Me.rtbToString.Text = mCustomer.ToString()

        Catch ex As NullReferenceException
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.SuspendLayout()
        '
        'btnNew
        '
        Me.btnNew.Visible = True
        '
        'btnDelete
        '
        Me.btnDelete.Visible = True
        '
        'btnSave
        '
        Me.btnSave.Visible = True
        '
        'btnRetrieve
        '
        Me.btnRetrieve.Enabled = True
        Me.btnRetrieve.Visible = True
        '
        'txtFax
        '
        Me.txtFax.Visible = True
        '
        'txtPhone
        '
        Me.txtPhone.Visible = True
        '
        'txtRegion
        '
        Me.txtRegion.Visible = True
        '
        'txtCountry
        '
        Me.txtCountry.Visible = True
        '
        'txtPostalCode
        '
        Me.txtPostalCode.Visible = True
        '
        'txtCity
        '
        Me.txtCity.Visible = True
        '
        'txtAddress
        '
        Me.txtAddress.Visible = True
        '
        'txtContactTitle
        '
        Me.txtContactTitle.Visible = True
        '
        'txtCustomerID
        '
        Me.txtCustomerID.Visible = True
        '
        'txtCompanyName
        '
        Me.txtCompanyName.Visible = True
        '
        'txtContactName
        '
        Me.txtContactName.Visible = True
        '
        'frmHowTo9_4
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(688, 325)
        Me.Name = "frmHowTo9_4"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmHowTo9_4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.txtCustomerID.Text = "ALFKI"
    End Sub
End Class

Public Class CCustomer9_4
    Inherits CCustomerData
    Implements ICustomer

#Region "Class Variables"
    Private mdsCust As dsCustomers
    Private mdrCust As dsCustomers.CustomersRow

    Private mstrCustomerID As String
    Private mstrCompanyName As String
    Private mstrContactName As String
    Private mstrContactTitle As String
    Private mstrAddress As String
    Private mstrCity As String
    Private mstrRegion As String
    Private mstrCountry As String
    Private mstrPostalCode As String
    Private mstrPhone As String
    Private mstrFax As String
#End Region
#Region "Constructors"

    Public Sub New(ByVal pCustomerIDToRetrieve As String)
        ' This constructor takes a valid CustomerID as a parameter, 
        ' and retrieves that row.  If the row does not exist, an 
        ' an Exception is thrown.

        ' Create an instance of the Customers DataSet
        mdsCust = New dsCustomers()

        Try
            ' Set the parameter for the select command so you retrieve
            ' the proper row from the table.

            ' MyBase is used to refer to members of the inherited class.
            ' It is only required in certain circumstances, like when 
            ' calling a constructor in the inherited class.
            MyBase.odaCustomers.SelectCommand.Parameters(0).Value = pCustomerIDToRetrieve

            ' A strongly-typed DataSet could contain multiple tables,
            ' so the table name to fill must be specified.

            odaCustomers.Fill(mdsCust, "Customers")
        Catch ex As Exception
            Throw New ApplicationException("The customer row could not be retrieved. " & ex.Message, ex)
        End Try

        If mdsCust.Customers.Rows.Count = 1 Then
            ' Option Strict disallows implicit type conversions.
            ' Even though the row returned by dsCustomers.Rows(0) is 
            ' actually of the type CustomersRow, the method is declared 
            ' as returning System.Data.DataRow.
            mdrCust = CType(mdsCust.Customers.Rows(0), dsCustomers.CustomersRow)
            readValuesFromDataRow()
        Else
            ' Throw an exception if no data was returned
            Throw New ApplicationException("The customer " & pCustomerIDToRetrieve & " was not found.")
        End If


    End Sub
#End Region
#Region "Properties"
    Public ReadOnly Property CustomerID() As String Implements ICustomer.CustomerID
        Get
            Return mstrCustomerID
        End Get
    End Property

    Public Property CompanyName() As String Implements ICustomer.CompanyName
        Get
            Return mstrCompanyName
        End Get
        Set(ByVal Value As String)
            mstrCompanyName = Value
        End Set
    End Property

    Public Property ContactName() As String Implements ICustomer.ContactName
        Get
            Return mstrContactName
        End Get
        Set(ByVal Value As String)
            mstrContactName = Value
        End Set
    End Property

    Public Property ContactTitle() As String Implements ICustomer.ContactTitle
        Get
            Return mstrContactTitle
        End Get
        Set(ByVal Value As String)
            mstrContactTitle = Value
        End Set
    End Property

    Public Property Address() As String Implements ICustomer.Address
        Get
            Return mstrAddress
        End Get
        Set(ByVal Value As String)
            mstrAddress = Value
        End Set
    End Property

    Public Property City() As String Implements ICustomer.City
        Get
            Return mstrCity
        End Get
        Set(ByVal Value As String)
            mstrCity = Value
        End Set
    End Property

    Public Property Region() As String Implements ICustomer.Region
        Get
            Return mstrRegion
        End Get
        Set(ByVal Value As String)
            mstrRegion = Value
        End Set
    End Property

    Public Property PostalCode() As String Implements ICustomer.PostalCode
        Get
            Return mstrPostalCode
        End Get
        Set(ByVal Value As String)
            mstrPostalCode = Value
        End Set
    End Property

    Property Country() As String Implements ICustomer.Country
        Get
            Return mstrCountry
        End Get
        Set(ByVal Value As String)
            mstrCountry = Value
        End Set
    End Property

    Public Property Phone() As String Implements ICustomer.Phone
        Get
            Return mstrPhone
        End Get
        Set(ByVal Value As String)
            mstrPhone = Value
        End Set
    End Property

    Public Property Fax() As String Implements ICustomer.Fax
        Get
            Return mstrFax
        End Get
        Set(ByVal Value As String)
            mstrFax = Value
        End Set
    End Property

#End Region
#Region "Methods"
    Public Overrides Function toString() As String Implements ICustomer.ToString
        Dim strReturn As String
        strReturn = Me.CustomerID & vbCrLf
        strReturn = strReturn & "Company:     " & Me.CompanyName & vbCrLf
        strReturn = strReturn & "Contact:     " & Me.ContactName & vbCrLf
        strReturn = strReturn & "Title:       " & Me.ContactTitle & vbCrLf
        strReturn = strReturn & "Address:     " & Me.Address & vbCrLf
        strReturn = strReturn & "City:        " & Me.City & vbCrLf
        strReturn = strReturn & "Postal Code: " & Me.PostalCode & vbCrLf
        strReturn = strReturn & "Country:     " & Me.Country & vbCrLf
        strReturn = strReturn & "Phone:       " & Me.Phone & vbCrLf
        strReturn = strReturn & "Fax:         " & Me.Fax & vbCrLf
        strReturn = strReturn & "Region       " & Me.Region & vbCrLf
        Return strReturn
    End Function

    Private Sub readValuesFromDataRow()
        ' There is an inherent difficulty in translating null values
        ' in a database into null values on the client side.  In the
        ' database, a null value is a null value.  When translating
        ' a null value to the client side, if you used null for the
        ' value, you would have to have error handling for 
        ' NullPointerExceptions, so instead, you would use a zero-
        ' length string to represent null.  This method handles this
        ' translation.
        With mdrCust
            ' Since the CustomerID and the CompanyName are both required
            ' values, you will not have handling for zero-length strings.
            mstrCustomerID = .CustomerID
            Me.CompanyName = .CompanyName

            If .IsContactNameNull Then
                Me.ContactName = ""
            Else
                Me.ContactName = .ContactName
            End If

            If .IsContactTitleNull Then
                Me.ContactTitle = ""
            Else
                Me.ContactTitle = .ContactTitle
            End If

            If .IsAddressNull Then
                Me.Address = ""
            Else
                Me.Address = .Address
            End If

            If .IsCityNull Then
                Me.City = ""
            Else
                Me.City = .City
            End If

            If .Is_RegionNull Then
                Me.Region = ""
            Else
                Me.Region = ._Region
            End If

            If .IsPostalCodeNull Then
                Me.PostalCode = ""
            Else
                Me.PostalCode = .PostalCode
            End If

            If .IsPhoneNull Then
                Me.Phone = ""
            Else
                Me.Phone = .Phone
            End If

            If .IsFaxNull Then
                Me.Fax = ""
            Else
                Me.Fax = .Fax
            End If
        End With
    End Sub


    Public Function save() As Boolean Implements ICustomer.Save

    End Function
    Public Function delete() As Boolean Implements ICustomer.Delete

    End Function

#End Region
End Class