Option Explicit On 
Option Strict On

Public Class frmHowTo9_7
    Inherits CustomerClasses.frmHowTo9xBase

    Private mCustomer As CCustomer9_7

    Private Sub btnRetrieve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRetrieve.Click

        Try

            mCustomer = New CCustomer9_7(New CCustomerID(Me.txtCustomerID.Text))

            GetProperties()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Protected Overrides Sub TextBoxChange(ByVal pstrProperty As String, ByVal pstrValue As String)

        Try

            Select Case pstrProperty

                Case "Address"
                    mCustomer.Address = pstrValue

                Case "CompanyName"
                    mCustomer.CompanyName = pstrValue

                Case "ContactTitle"
                    mCustomer.ContactTitle = pstrValue

                Case "ContactName"
                    mCustomer.ContactName = pstrValue

                Case "City"
                    mCustomer.City = pstrValue

                Case "Zip"
                    mCustomer.PostalCode = pstrValue

                Case "Country"
                    mCustomer.Country = pstrValue

                Case "Region"
                    mCustomer.Region = pstrValue

                Case "Phone"
                    mCustomer.Phone.StringValue = pstrValue

                Case "Fax"
                    mCustomer.Fax.StringValue = pstrValue

            End Select

            Me.rtbToString.Text = mCustomer.ToString()

        Catch ex As NullReferenceException
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub GetProperties()

        Me.txtAddress.Text = mCustomer.Address
        Me.txtCity.Text = mCustomer.City
        Me.txtCompanyName.Text = mCustomer.CompanyName
        Me.txtContactName.Text = mCustomer.ContactName
        Me.txtContactTitle.Text = mCustomer.ContactTitle
        Me.txtCountry.Text = mCustomer.Country
        Me.txtCustomerID.Text = mCustomer.CustomerID.CustomerID
        Me.txtFax.Text = mCustomer.Fax.StringValue
        Me.txtPhone.Text = mCustomer.Phone.StringValue
        Me.txtRegion.Text = mCustomer.Region
        Me.txtZip.Text = mCustomer.PostalCode

    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click

        Try

            mCustomer = Nothing
            If Me.txtCustomerID.Text.Length > 0 Then
                If Me.txtCompanyName.Text.Length > 0 Then
                    mCustomer = New CCustomer9_7(New CCustomerID(Me.txtCustomerID.Text), Me.txtCompanyName.Text)
                Else
                End If
            Else
                Select Case MsgBox("A CustomerID is required for a new Customer.  Would you like a new customer created for you?", MsgBoxStyle.YesNoCancel)
                    Case MsgBoxResult.Yes
                        Me.txtCustomerID.Text = "FINMR"
                        Me.txtCompanyName.Text = "Finn's Fantastic Foodstuffs"
                        Me.btnNew_Click(sender, e)
                        mCustomer.ContactName = "Finnegan M. Ramos-O'Neill"
                        mCustomer.City = "Albuquerque"
                        mCustomer.ContactTitle = "Proprietor"
                        mCustomer.Address = "1234 Rio Grande Boulevard"
                        mCustomer.Country = "USA"
                        mCustomer.Phone = New CPhoneNo("505-123-4567")
                    Case MsgBoxResult.Cancel, MsgBoxResult.No
                        Me.ClearAllTextBoxes()
                        Exit Sub
                End Select
            End If
            GetProperties()
            Me.rtbToString.Text = mCustomer.ToString
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Try
            If mCustomer.save() Then
                MsgBox("Save succeeded.")
            Else
                MsgBox("Save failed.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Try
            If mCustomer.Delete() Then
                MsgBox("Delete succeeded.")
                mCustomer = Nothing
                ClearAllTextBoxes()
            Else
                MsgBox("Delete failed.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.SuspendLayout()
        '
        'btnNew
        '
        Me.btnNew.Enabled = True
        Me.btnNew.Visible = True
        '
        'btnDelete
        '
        Me.btnDelete.Enabled = True
        Me.btnDelete.Visible = True
        '
        'btnSave
        '
        Me.btnSave.Enabled = True
        Me.btnSave.Visible = True
        '
        'btnRetrieve
        '
        Me.btnRetrieve.Enabled = True
        Me.btnRetrieve.Visible = True
        '
        'txtFax
        '
        Me.txtFax.Visible = True
        '
        'txtPhone
        '
        Me.txtPhone.Visible = True
        '
        'txtRegion
        '
        Me.txtRegion.Visible = True
        '
        'txtCountry
        '
        Me.txtCountry.Visible = True
        '
        'txtZip
        '
        Me.txtZip.Visible = True
        '
        'txtCity
        '
        Me.txtCity.Visible = True
        '
        'txtAddress
        '
        Me.txtAddress.Visible = True
        '
        'txtContactTitle
        '
        Me.txtContactTitle.Visible = True
        '
        'txtCustomerID
        '
        Me.txtCustomerID.Visible = True
        '
        'txtCompanyName
        '
        Me.txtCompanyName.Visible = True
        '
        'txtContactName
        '
        Me.txtContactName.Visible = True
        '
        'frmHowTo9_7
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(688, 325)
        Me.Name = "frmHowTo9_7"
        Me.ResumeLayout(False)

    End Sub

#End Region

End Class

Public Interface ICustomer9_7
#Region "Properties"
    'Define properties for this interface
    'that match the table structure in name and data type
    ReadOnly Property CustomerID() As CCustomerID
    Property CompanyName() As String
    Property ContactName() As String
    Property ContactTitle() As String
    Property Address() As String
    Property City() As String
    Property Region() As String
    Property PostalCode() As String
    Property Country() As String
    Property Phone() As CPhoneNo
    Property Fax() As CPhoneNo
#End Region
#Region "Methods"
    'To update record, a user would have needed to
    'retrieve data before modifying any of the properties.
    Function Save() As Boolean
    Function Delete() As Boolean
    Function ToString() As String
#End Region
End Interface

Public Class CCustomer9_7
    Inherits CCustomerData
    Implements ICustomer9_7

#Region "Class Variables"
    Private mdsCust As dsCustomers
    Private mdrCust As dsCustomers.CustomersRow

    Private mfNew As Boolean

    Private WithEvents mCustomerID As CCustomerID
    Private mstrCompanyName As String
    Private mstrContactName As String
    Private mstrContactTitle As String
    Private mstrAddress As String
    Private mstrCity As String
    Private mstrRegion As String
    Private mstrCountry As String
    Private mstrPostalCode As String
    Private WithEvents mPhone As CPhoneNo
    Private WithEvents mFax As CPhoneNo
#End Region
#Region "Constructors"
    Public Sub New(ByVal pCustomerIDToRetrieve As CCustomerID)

        ' Create an instance of the Customers DataSet
        mdsCust = New dsCustomers()

        Try
            ' Set the parameter for the select command so you retrieve
            ' the proper row from the table.

            ' MyBase is used to refer to members of the inherited class.
            ' It is only required in certain circumstances, like when 
            ' calling a constructor in the inherited class.
            MyBase.odaCustomers.SelectCommand.Parameters(0).Value = pCustomerIDToRetrieve.CustomerID

            ' A strongly-typed DataSet could contain multiple tables,
            ' so the table name to fill must be specified.

            odaCustomers.Fill(mdsCust, "Customers")
        Catch ex As Exception
            Throw New ApplicationException("The customer row could not be retrieved. " & ex.Message, ex)
        End Try

        If mdsCust.Customers.Rows.Count = 1 Then
            ' Option Strict disallows implicit type conversions.
            ' Even though the row returned by dsCustomers.Rows(0) is 
            ' actually of the type CustomersRow, the method is declared 
            ' as returning System.Data.DataRow.
            mdrCust = CType(mdsCust.Customers.Rows(0), dsCustomers.CustomersRow)
            ReadValuesFromDataRow()
        Else
            ' Throw an exception if no data was returned
            Throw New ApplicationException("The customer " & pCustomerIDToRetrieve.CustomerID & " was not found.")
        End If

    End Sub
    Public Sub New(ByVal pCustomerID As CCustomerID, _
               ByVal pCompanyName As String)
        ' This constructor is used to create new Customer records
        ' in the database.  This constructor should be used when
        ' working independently of the CCustomers class.

        ' Instead of accepting a string that has to be validated,
        ' this constructor accepts a CCustomerID object that by
        ' definition is valid.

        If Not pCustomerID.Exists Then
            ' If you recall, there used to be an additional condition
            ' in this If... Then that checked the length of the CustomerID.
            ' Now, the CCustomerID guarantees a valid CustomerID.

            mdsCust = New dsCustomers()
            mfNew = True

            ' Just to make sure, create a new CCustomerID object.  If you
            ' don't, consumers of this class will retain a pointer to this
            ' object instance, allowing back to consumer to change the value
            ' of the shared CCustomerID object unbeknownst to the CCustomer object.
            mCustomerID = New CCustomerID(pCustomerID)

            Me.CompanyName = pCompanyName
            mstrContactName = ""
            mstrContactTitle = ""
            mstrAddress = ""
            mstrCity = ""
            mstrRegion = ""
            mstrCountry = ""
            mstrPostalCode = ""
            mPhone = New CBusinessPhone("", New CExtension(""))
            mFax = New CPhoneNo("")
        Else
            ' When you throw an InvalidCustomerIDEException, you won't necessarily
            ' have a valid CustomerID, so this exception has to accept a string
            ' instead of object.  This InvalidCustomerIDException is used to express
            ' that the CustomerID for the new customer already exists in the database.
            Throw New CCustomerID.InvalidCustomerIDException(pCustomerID.CustomerID)
        End If
    End Sub
    Public Sub New(ByVal pCustomerID As CCustomerID, _
                    ByVal pCompanyName As String, _
                    ByVal pContactName As String, _
                    ByVal pContactTitle As String, _
                    ByVal pAddress As String, _
                    ByVal pCity As String, _
                    ByVal pRegion As String, _
                    ByVal pPostalCode As String, _
                    ByVal pCountry As String, _
                    ByVal pPhone As CBusinessPhone, _
                    ByVal pFax As CPhoneNo)
        ' By calling the constructor with the CustomerID and CompanyName,
        ' this constructor must, by default, also be used independently
        ' of the CCustomers class.
        Me.New(pCustomerID, pCompanyName)
        Me.Address = pAddress
        Me.City = pCity
        Me.ContactName = pContactName
        Me.ContactTitle = pContactTitle
        Me.Fax = New CPhoneNo(pFax)
        Me.Phone = New CBusinessPhone(pPhone)
        Me.PostalCode = pPostalCode
        Me.Country = pCountry
        Me.Region = pRegion

    End Sub

#End Region
#Region "Properties"
    Public ReadOnly Property CustomerID() As CCustomerID Implements ICustomer9_7.CustomerID
        Get
            Return mCustomerID
        End Get
    End Property

    Public Property CompanyName() As String Implements ICustomer9_7.CompanyName
        Get
            Return mstrCompanyName
        End Get
        Set(ByVal Value As String)
            Select Case Value.Length
                Case Is = 0
                    Throw New ArgumentNullException("Value", "The CompanyName property cannot be a zero-length string.")

                Case Is <= 40
                    mstrCompanyName = Value

                Case Is > 40
                    Throw New MaximumStringLengthExceededException(40, "CompanyName", Value)

            End Select
        End Set
    End Property

    Public Property ContactName() As String Implements ICustomer9_7.ContactName
        Get
            Return mstrContactName
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 30 Then
                mstrContactName = Value
            Else
                Throw New MaximumStringLengthExceededException(30, "ContactName", Value)
            End If
        End Set
    End Property

    Public Property ContactTitle() As String Implements ICustomer9_7.ContactTitle
        Get
            Return mstrContactTitle
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 30 Then
                mstrContactTitle = Value
            Else
                Throw New MaximumStringLengthExceededException(30, "ContactTitle", Value)
            End If
        End Set
    End Property

    Public Property Address() As String Implements ICustomer9_7.Address
        Get
            Return mstrAddress
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 60 Then
                mstrAddress = Value
            Else
                Throw New MaximumStringLengthExceededException(60, "Address", Value)
            End If
        End Set
    End Property

    Public Property City() As String Implements ICustomer9_7.City
        Get
            Return mstrCity
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 15 Then
                mstrCity = Value
            Else
                Throw New MaximumStringLengthExceededException(15, "City", Value)
            End If
        End Set
    End Property

    Public Property Region() As String Implements ICustomer9_7.Region
        Get
            Return mstrRegion
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 15 Then
                mstrRegion = Value
            Else
                Throw New MaximumStringLengthExceededException(15, "Region", Value)
            End If
        End Set
    End Property

    Public Property PostalCode() As String Implements ICustomer9_7.PostalCode
        Get
            Return mstrPostalCode
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 10 Then
                mstrPostalCode = Value
            Else
                Throw New MaximumStringLengthExceededException(10, "Postal Code", Value)
            End If
        End Set
    End Property

    Property Country() As String Implements ICustomer9_7.Country
        Get
            Return mstrCountry
        End Get
        Set(ByVal Value As String)
            If Value.Length <= 15 Then
                mstrCountry = Value
            Else
                Throw New MaximumStringLengthExceededException(15, "Country", Value)
            End If
        End Set
    End Property

    Public Property Phone() As CPhoneNo Implements ICustomer9_7.Phone
        Get
            Return mPhone
        End Get
        Set(ByVal Value As CPhoneNo)
            mPhone = New CPhoneNo(Value)
        End Set
    End Property

    Public Property Fax() As CPhoneNo Implements ICustomer9_7.Fax
        Get
            Return mFax
        End Get
        Set(ByVal Value As CPhoneNo)
            mFax = New CPhoneNo(Value)
        End Set
    End Property
#End Region
#Region "Methods"
    Public Function save() As Boolean Implements ICustomer9_7.Save

        Dim nState As DataRowState

        If mfNew Then
            ' If this is a new Customer, you need to add a DataRow
            ' to the DataSet.
            mdrCust = mdsCust.Customers.AddCustomersRow(mCustomerID.CustomerID, _
                mstrCompanyName, mstrContactName, mstrContactTitle, mstrAddress, mstrCity, _
                mstrRegion, mstrPostalCode, mstrCountry, mPhone.StringValue, mFax.StringValue)

            nState = DataRowState.Added
            mfNew = False
        Else
            nState = DataRowState.Modified
        End If

        ' Begin editing the DataRow
        mdrCust.BeginEdit()

        ' If you have a problew writing values to the DataRow, you want to
        ' catch the exception, cancel editing, reject the changes, and
        ' immediately dump out of the method with a return value of false.
        Try
            WriteValuesToDataRow()
        Catch ex As Exception
            mdrCust.CancelEdit()
            mdrCust.RejectChanges()
            Return False
        End Try

        ' If you succeed in writing the new values to the DataRow, you 
        ' end the editing block, and then write the changes to the
        ' database. If there is a problem writing to the DB, then
        ' reject the changes to the row, and return false.
        mdrCust.EndEdit()
        If WriteChangesToDB(nState) Then
            Return True
        Else
            mdrCust.RejectChanges()
            Return False
        End If

    End Function

    Public Function Delete() As Boolean Implements ICustomer9_7.Delete

        If mfNew Then

            ' If you're working with a new record, you don't need to 
            ' communicate with the database, so clear the properties
            ' of the object and return that the delete succeeded.
            Clear()
            Return True

        Else

            ' If this is an existing record, flag the DataRow as
            ' deleted, then write the changes to the DB. 
            mdrCust.Delete()

            If WriteChangesToDB(DataRowState.Deleted) Then
                Clear()
                MsgBox(mdsCust.Customers.Count.ToString)
                Return True
            Else
                mdrCust.RejectChanges()
                Return False
            End If

        End If

    End Function

    Private Sub Clear()
        ' Consumers of this class should be savvy enough  to dispose 
        ' of the object after they call the delete method, but
        ' to be sure, let's set all the pointers to null, so if a
        ' developer forgets... NullPointerException
        mdsCust = Nothing
        mdrCust = Nothing
        mCustomerID = Nothing
        mstrCompanyName = Nothing
        mstrContactName = Nothing
        mstrContactTitle = Nothing
        mstrAddress = Nothing
        mstrCity = Nothing
        mstrRegion = Nothing
        mstrCountry = Nothing
        mstrPostalCode = Nothing
        mPhone = Nothing
        mFax = Nothing
    End Sub

    Private Function WriteChangesToDB(ByVal pStateToHandle As DataRowState) As Boolean

        Try
            ' Create a dataset of only those rows that have been 
            ' changed (specifically, those changed in the manner
            ' specified by the DataRowState.
            Dim dsChanges As DataSet = mdsCust.GetChanges(pStateToHandle)

            ' Pass this subset of the DataSet to the DataAdapter
            ' to write the changes to the database. The DataAdapter
            ' will handle all calls to the delete, insert and update
            ' commands.
            odaCustomers.Update(dsChanges)

        Catch ex As Exception
            ' If the update fails, communicate this back to
            ' the calling function.
            mdsCust.RejectChanges()
            Return False

        End Try

        ' Update the customers Dataset to reflect the changes
        ' you have made.
        mdsCust.AcceptChanges()
        Return True

    End Function

    Private Sub WriteValuesToDataRow()
        ' There is an inherent difficulty in translating null values
        ' in a database into null values on the client side.  In this
        ' example, you are using zero-length strings to represent null.  
        ' This method converts zero-length strings into null values by
        ' calling the Set[Property]Null methods of the appropriate
        ' property.

        ' This technique allows consumers to modify properties (class-
        ' level variables) but leaves the DataRow intact until the 
        ' save method is called. In essence, the DataRow holds the
        ' original state of the Customers row, while the class-level
        ' variables hold the current state. This method synchronizes
        ' the two.
        With mdrCust
            .CompanyName = mstrCompanyName

            If mstrAddress.Length = 0 Then
                .SetAddressNull()
            Else
                .Address = mstrAddress
            End If

            If mstrRegion.Length = 0 Then
                .Set_RegionNull()
            Else
                ._Region = mstrRegion
            End If

            If mstrCountry.Length = 0 Then
                .SetCountryNull()
            Else
                .Country = mstrCountry
            End If

            If mstrPostalCode.Length = 0 Then
                .SetPostalCodeNull()
            Else
                .PostalCode = mstrPostalCode

            End If

            If mPhone.StringValue.Length = 0 Then
                .SetPhoneNull()
            Else
                .Phone = mPhone.StringValue
            End If

            If mFax.StringValue.Length = 0 Then
                .SetFaxNull()
            Else
                .Fax = mFax.StringValue
            End If

            If mstrContactTitle.Length = 0 Then
                .SetContactTitleNull()
            Else
                .ContactTitle = mstrContactTitle
            End If

            If mstrContactName.Length = 0 Then
                .SetContactNameNull()
            Else
                .ContactName = mstrContactName
            End If

            If mstrCity.Length = 0 Then
                .SetCityNull()
            Else
                .City = mstrCity
            End If
        End With
    End Sub

    Private Sub ReadValuesFromDataRow()
        ' There is an inherent difficulty in translating null values
        ' in a database into null values on the client side.  In the
        ' database, a null value is a null value.  When translating
        ' a null value to the client side, if you used null for the
        ' value, you would have to have error handling for 
        ' NullPointerExceptions, so instead, you would use a zero-
        ' length string to represent null.  This method handles this
        ' translation.

        ' This technique allows consumers to modify properties (class-
        ' level variables) but leaves the DataRow intact until the 
        ' save method is called. In essence, the DataRow holds the
        ' original state of the Customers row, while the class-level
        ' variables hold the current state. This method sets the
        ' class-level variables to the original state of the DataRow.
        ' At the moment, this method is just used to initialize the
        ' class, but it could also be the basis for a cancel or reset 
        ' method

        With mdrCust
            ' Since the CustomerID and the CompanyName are both required
            ' values, you will not have handling for zero-length strings.
            mCustomerID = New CCustomerID(.CustomerID)
            Me.CompanyName = .CompanyName

            If .IsContactNameNull Then
                Me.ContactName = ""
            Else
                Me.ContactName = .ContactName
            End If

            If .IsContactTitleNull Then
                Me.ContactTitle = ""
            Else
                Me.ContactTitle = .ContactTitle
            End If

            If .IsAddressNull Then
                Me.Address = ""
            Else
                Me.Address = .Address
            End If

            If .IsCityNull Then
                Me.City = ""
            Else
                Me.City = .City
            End If

            If .Is_RegionNull Then
                Me.Region = ""
            Else
                Me.Region = ._Region
            End If

            If .IsPostalCodeNull Then
                Me.PostalCode = ""
            Else
                Me.PostalCode = .PostalCode
            End If

            If .IsCountryNull Then
                Me.Country = ""
            Else
                Me.Country = .Country
            End If

            If .IsPhoneNull Then
                Me.Phone = New CBusinessPhone("", New CExtension(""))
            Else
                Me.Phone = New CBusinessPhone(.Phone, New CExtension(""))
            End If

            If .IsFaxNull Then
                Me.Fax = New CPhoneNo("")
            Else
                Me.Fax = New CPhoneNo(.Fax)
            End If
        End With
    End Sub

    Public Overrides Function ToString() As String Implements ICustomer9_7.ToString
        Dim strReturn As String
        strReturn = Me.CustomerID.CustomerID & vbCrLf
        strReturn = strReturn & "Company:     " & Me.CompanyName & vbCrLf
        strReturn = strReturn & "Contact:     " & Me.ContactName & vbCrLf
        strReturn = strReturn & "Title:       " & Me.ContactTitle & vbCrLf
        strReturn = strReturn & "Address:     " & Me.Address & vbCrLf
        strReturn = strReturn & "City:        " & Me.City & vbCrLf
        strReturn = strReturn & "Postal Code: " & Me.PostalCode & vbCrLf
        strReturn = strReturn & "Country:     " & Me.Country & vbCrLf
        strReturn = strReturn & "Phone:       " & Me.Phone.StringValue & vbCrLf
        strReturn = strReturn & "Fax:         " & Me.Fax.StringValue & vbCrLf
        strReturn = strReturn & "Region       " & Me.Region & vbCrLf
        Return strReturn
    End Function

#End Region
#Region "Event Handlers"

    Private Sub mPhone_StringValueBeforeUpdate(ByVal pstrValue As String, ByRef pCancel As Boolean) Handles mPhone.StringValueBeforeUpdate
        If pstrValue.Length <= 24 Then
            pCancel = False
        Else
            pCancel = True
            Throw New MaximumStringLengthExceededException(24, "Phone", pstrValue)
        End If
    End Sub

    Private Sub mFax_StringValueBeforeUpdate(ByVal pstrValue As String, ByRef pCancel As Boolean) Handles mFax.StringValueBeforeUpdate
        If pstrValue.Length <= 24 Then
            pCancel = False
        Else
            pCancel = True
            Throw New MaximumStringLengthExceededException(24, "Fax", pstrValue)
        End If
    End Sub
    Private Sub mCustomerID_BeforeUpdate(ByVal pstrCustomerID As String, ByRef fCancel As Boolean) Handles mCustomerID.BeforeUpdate
        fCancel = True
    End Sub
#End Region


End Class